;*************************************************************************
; Copyright (c) 2002 The University of Chicago, as Operator of Argonne
; National Laboratory.
; Copyright (c) 2002 The Regents of the University of California, as
; Operator of Los Alamos National Laboratory.
; This file is distributed subject to a Software License Agreement found
; in the file LICENSE that is included with this distribution. 
;*************************************************************************
pro array_ascii
	catch, error_status
	if(error_status NE 0) then begin
		print, 'ERROR_MESSAGE:',!ERR_STRING
		if (OBJ_VALID(a)) then OBJ_DESTROY, a
		return
	endif

a=obj_new('sdds_table','array_ascii.sdds', /NEW)
if (NOT OBJ_VALID(a)) then MESSAGE, 'object-a- not created!'

a->setarraydefinition, {NAME:'double'}
a->setarraydefinition, {NAME:'float',TYPE:'FLOAT',DIMENSIONS:3l}
a->setarraydefinition, {NAME:'long',TYPE:'LONG',DESCRIPTION:'a long'}
a->setarraydefinition, {NAME:'short',TYPE:'SHORT',UNITS:'Volts',DIMENSIONS:3l}
a->setarraydefinition, {NAME:'string1',TYPE:'STRING',DESCRIPTION:'a date',DIMENSIONS:1l}
a->setarraydefinition, {NAME:'byte',TYPE:'BYTE',SYMBOL:'$x$y',DIMENSIONS:4l}

a->startTable, 1

d=[ [1.1D,2.2D,3.3D], $
[4.4D,5.5D,6.6D] ]

f=[ [[1.1,2.2,3.3],[4.4,5.5,6.6],[7.7,8.8,9.9]],$
 [[1.1,2.2,3.3],[4.4,5.5,6.6],[7.7,8.8,9.9]], $
 [[1.1,2.2,3.3],[4.4,5.5,6.6],[7.7,8.8,9.9]] ]

la=[ [1l,2l,3l,4l,5l], $
[6l,7l,8l,9l,10l] ]

s= [ [[0,2,3,4,5],[0,7,8,9,10],[0,12,13,14,15]], $
[[1,2,3,4,5],[1,7,8,9,10],[1,12,13,14,15]], $
[[2,2,3,4,5],[2,7,8,9,10],[2,12,13,14,15]] ]

strings=['1','2','3','4','5']

b=make_array(5,4,3,2,/BYTE,VALUE=5B)

a->setArray,'double',d
a->setArray,'float',f
a->setArray,'long',la
a->setArray,'short',s
a->setArray,'byte',b
a->setArray,'string1',strings

a->writeTable

d1=d+1.1D
f1=f+1.1
la1=la+1l
s1=s+1
b1=b+1
strings1=['2','3','4','5','6']

a->setArray,'double',d1
a->setArray,'float',f1
a->setArray,'long',la1
a->setArray,'short',s1
a->setArray,'byte',b1
a->setArray,'string1',strings1

a->writeTable

obj_destroy, a

a=obj_new('sdds_table','array_ascii.sdds')
if (NOT OBJ_VALID(a)) then MESSAGE, 'object-a- not created!'

r=a->readTable()

rd=a->getArray('double')
rf=a->getArray('float')
rl=a->getArray('long')
rs=a->getArray('short')
rst=a->getArray('string1')
rb=a->getArray('byte')

r=a->readTable()

rd1=a->getArray('double')
rf1=a->getArray('float')
rl1=a->getArray('long')
rs1=a->getArray('short')
rst1=a->getArray('string1')
rb1=a->getArray('byte')

obj_destroy, a
i=0l
j=0l
k=2l
l=3l
dim=[3,2,1,1]
for i=0 , dim[3]-1 do begin
	for j=0, dim[2]-1 do begin
		for k=0, dim[1]-1 do begin
			for l=0, dim[0]-1 do begin
				if(rd[l,k,j,i] NE d[l,k,j,i]) then print, i, ' r!=rd'
				if(rd1[l,k,j,i] NE d1[l,k,j,i]) then print, i, ' d1!=rd1',d1[l,k,j,i],rd1[l,k,j,i]
			end
		end
	end
end
dim=[3,3,3,1]
for i=0 , dim[3]-1 do begin
	for j=0, dim[2]-1 do begin
		for k=0, dim[1]-1 do begin
			for l=0, dim[0]-1 do begin
				if(rf[l,k,j,i] NE f[l,k,j,i]) then print, i, ' f!=rf'
				if(rf1[l,k,j,i] NE f1[l,k,j,i]) then print, i, ' f1!=rf1'
			end
		end
	end
end
dim=[5,2,1,1]
for i=0 , dim[3]-1 do begin
	for j=0, dim[2]-1 do begin
		for k=0, dim[1]-1 do begin
			for l=0, dim[0]-1 do begin
				if(la[l,k,j,i] NE rl[l,k,j,i]) then print, i, ' l!=rl'
				if(la1[l,k,j,i] NE rl1[l,k,j,i]) then print, i, ' l1!=rl1'
			end
		end
	end
end
dim=[5,3,3,1]
for i=0 , dim[3]-1 do begin
	for j=0, dim[2]-1 do begin
		for k=0, dim[1]-1 do begin
			for l=0, dim[0]-1 do begin
				if(s[l,k,j,i] NE rs[l,k,j,i]) then print, i, ' s!=rs'
				if(s1[l,k,j,i] NE rs1[l,k,j,i]) then print, i, ' s1!=rs1'
			end
		end
	end
end
dim=[5,4,3,2]
for i=0 , dim[3]-1 do begin
	for j=0, dim[2]-1 do begin
		for k=0, dim[1]-1 do begin
			for l=0, dim[0]-1 do begin
				if(b[l,k,j,i] NE rb[l,k,j,i]) then print, i, ' b!=rb'
				if(b1[l,k,j,i] NE rb1[l,k,j,i]) then print, i, ' b1!=rb1'
			end
		end
	end
end
dim=[5,1,1,1]
for i=0 , dim[3]-1 do begin
	for j=0, dim[2]-1 do begin
		for k=0, dim[1]-1 do begin
			for l=0, dim[0]-1 do begin
				if(strings[l,k,j,i] NE rst[l,k,j,i]) then print, i, ' b!=rb'
				if(strings1[l,k,j,i] NE rst1[l,k,j,i]) then print, i, ' b1!=rb1'
			end
		end
	end
end


return
end
